SystemOrganization addCategory: 'Seaside-GemStone-Email'!

!GRGemStonePlatform methodsFor: '*seaside-gemstone-email' stamp: 'dkh 05/17/2011 18:53'!
seasideDeliverEmailMessage: aWAEmailMessage
    

	| client |
	client := SendMail new.

	"user login information if applicable"
	self seasideSmtpUsername ifNotNilDo: [:username | 
		client user: username.
		self seasideSmtpPassword ifNotNilDo: [:password |
			client password: password]].

	"use HELO/EHLO ip address format [127.0.0.1] if local host name is ip"
	(self seasideIsIpAddress: client ownDomainName)
		ifTrue: [client ownDomainName: '[', client ownDomainName, ']'].

	"deliver the mail"
	client 
		mailhostName: self seasideSmtpServer;
		smtpPort: self seasideSmtpPort;
		from: aWAEmailMessage from address greaseString;
		to: (String streamContents:[:str | 
			aWAEmailMessage recipientsAddresses do:[:addr | str nextPutAll: addr greaseString] separatedBy: [str nextPut:$;]]);
		text: aWAEmailMessage plainMessage.

	client send.! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-email' stamp: 'topa 10/14/2010 15:19'!
seasideIsIpAddress: aString

	| ip |
	ip := aString findTokens: '.'.
	^ (ip size = 4) 
		ifFalse: [false]
		ifTrue: [
			ip allSatisfy: [:ea | ea greaseInteger
				ifNil: [false]
				ifNotNilDo: [:num | num between: 0 and: 255]]]! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-email' stamp: 'topa 10/14/2010 13:19'!
seasideSmtpPassword

	^ self seasideApplicationPreferenceAt: #smtpPassword ifAbsent: [nil]! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-email' stamp: 'topa 10/14/2010 13:20'!
seasideSmtpPort

	^ self seasideApplicationPreferenceAt: #smtpPort ifAbsent: [SendMail new smtpPort]! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-email' stamp: 'topa 10/14/2010 13:22'!
seasideSmtpServer
	
	^ self seasideApplicationPreferenceAt: #smtpServer ifAbsent: [SendMail mailhost]! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-email' stamp: 'topa 10/14/2010 13:19'!
seasideSmtpUsername

	^ self seasideApplicationPreferenceAt: #smtpUsername ifAbsent: [nil]! !

!GRPackage class methodsFor: '*seaside-gemstone-email' stamp: 'DaleHenrichs 06/03/2010 12:32'!
seasideGemStoneEmail
	^ self new
		name: 'Seaside-GemStone-Email';
		description: 'GemStone implementation classes for the package "Seaside-Email".';
		addDependency: 'Seaside-Email';
		url: #gemstoneUrl;
		yourself! !

WAErrorHandler subclass: #WAEmailErrorHandler
	instanceVariableNames: ''
	classVariableNames: 'From To'
	poolDictionaries: ''
	category: 'Seaside-GemStone-Email'!

!WAEmailErrorHandler commentStamp: 'dkh 11/24/2009 11:18' prior: 0!
A WAEmailErrorHandler is an error handler that sends out email messages with the stack strace. 

This class can be used as is by sending the class-side message #configureHandlerFrom:to:mailhost: to configure the from, to and mailhost to be used.

If you want to create a custom email handler, then subclass this class and override the #to, #from, and #handleDefault  messages.!

!WAEmailErrorHandler class methodsFor: 'configuration' stamp: 'dkh 11/24/2009 10:31'!
configureHandlerFrom: fromEmailAddress to: toEmailAddress mailhost: mailhost
	"WAEmailErrorHandler 
		configureHandlerFrom: 'dhenrich@gemstone.com' 
		to: 'dhenrich@gemstone.com' 
		mailhost: 'mail.gemstone.com'
	"

	From := WAEmailAddress address: fromEmailAddress.
	To := WAEmailAddress address: toEmailAddress.
	SendMail mailhost: mailhost! !

!WAEmailErrorHandler methodsFor: 'private' stamp: 'dkh 11/11/2009 11:04'!
bodyFor: anError
	^WAStringEmailBody string: (GsProcess stackReportToLevel: 1000)! !

!WAEmailErrorHandler methodsFor: 'private' stamp: 'dkh 11/24/2009 10:24'!
from
	"ansers the WAEmailAddress instance used as a sender address"	
	
	^From! !

!WAEmailErrorHandler methodsFor: 'actions' stamp: 'dkh 11/24/2009 10:45'!
handleDefault: anException

	self sendFailFor: anException.
	self responseFor: anException! !

!WAEmailErrorHandler methodsFor: 'private' stamp: 'dkh 11/24/2009 10:45'!
responseFor: anException
	| content |
	content := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root | root title: 'Internal Error ' ];
		render: [ :html |
			html heading level1; with: anException description.
			html paragraph: 'An internal error has been encountered. The maintainers of the site have been notified.' ].
	self requestContext respond: [ :response |
		response
			internalError;
			nextPutAll: content ]! !

!WAEmailErrorHandler methodsFor: 'private' stamp: 'pmm 9/14/2008 14:48'!
sendFailFor: anError
	| message |
	message := WAEmailMessage
		from: self from
		to: self to
		subject: (self subjectFor: anError).
	message body: (self bodyFor: anError).
	message send! !

!WAEmailErrorHandler methodsFor: 'private' stamp: 'dkh 11/11/2009 11:02'!
subjectFor: anError
	^anError description! !

!WAEmailErrorHandler methodsFor: 'private' stamp: 'dkh 11/24/2009 10:24'!
to
	"ansers the WAEmailAddress instance to which the error mail should be sent"

	^To! !
